REM  *****              EPROM Programmer and Emulator            *****
REM  *****                 Hex Conversion Software               *****
REM  *****               (C) 1991-1994 Paul Stenning             *****
REM
REM  *****        Source Code for Microsoft QuickBASIC V4.5      *****
REM  *****            and QBASIC (MS-DOS 5.0 and later)          *****
REM
REM
REM  *****           See README.TXT For Use Restrictions         *****


REM Version 1.20 - 21/07/94
REM Version 1.30 - 25/10/94  --  Modify to suit commas in DOS-6 DIR command
REM Version 1.40 - 20/12/94  --  Fix bug which causes data loss on files with
REM                              number of bytes not a multiple of 16.
REM Version 1.50 - 27/12/98  --  Patch to work with Windows 95

DECLARE SUB PutByte (Address&, Value%)
DECLARE FUNCTION GetByte% (Address&)
DECLARE SUB Percent (Value%, Message$)
DECLARE SUB Mistake (x1%, Message$, x2%, x3%)
DECLARE FUNCTION LoByte% (Number&)
DECLARE FUNCTION HiByte% (Number&)
DECLARE FUNCTION LoWord% (Number&)
DECLARE FUNCTION FileSize& (FileSpec$)

DECLARE SUB IntelLoad (FileName$)
DECLARE SUB SLoad (FileName$)
DECLARE SUB TekLoad (FileName$)
DECLARE SUB RCALoad (FileName$)
DECLARE SUB AsciiHexLoad (FileName$)
DECLARE SUB AsciiBinLoad (FileName$)
DECLARE SUB BinaryLoad (FileName$)
DECLARE SUB AsciiTextLoad (FileName$)

DECLARE SUB AsciiTextSave (FileName$, MaxAddr&)
DECLARE SUB IntelSave (FileName$, MaxAddr&)
DECLARE SUB SSave (FileName$, MaxAddr&)
DECLARE SUB RCASave (FileName$, MaxAddr&)
DECLARE SUB TekSave (FileName$, MaxAddr&)
DECLARE SUB AsciiHexSave (FileName$, MaxAddr&)
DECLARE SUB AsciiBinSave (FileName$, MaxAddr&)
DECLARE SUB BinarySave (FileName$, MaxAddr&)

Init:
    SCREEN 0
    WIDTH 80
    COLOR 7, 0
    CLS
    IF LEFT$(COMMAND$, 2) = "/?" THEN GOTO Help
    REM $DYNAMIC
    DIM SHARED HexData1%(0 TO 16383)
    DIM SHARED HexData2%(0 TO 16383)
    DIM SHARED Loaded%, MaxAddr&, DOS
    PRINT
    PRINT "Hex File Conversion Software Loading - Please Wait"
    ON ERROR GOTO DosError
    Temp% = 0
    SHELL "VER > HEX-CONV.TMP"
    OPEN "HEX-CONV.TMP" FOR INPUT AS #1
    DO UNTIL EOF(1) OR Temp% = 1
        LINE INPUT #1, Temp$
        Temp$ = LTRIM$(RTRIM$(Temp$))
        IF LEN(Temp$) > 0 THEN
            DOS = VAL(RIGHT$(Temp$, 5))
            IF DOS < 1 THEN DOS = 950
            Temp% = 1
        END IF
    LOOP
    CLOSE #1
    KILL "HEX-CONV.TMP"
    IF DOS < 3 THEN GOTO WrongDos
    ON ERROR GOTO 0

LoadMenu:
    CLS
    MaxAddr& = 0
    Loaded% = 1
    CLOSE
    ON ERROR GOTO 0
    LOCATE 2, 20, 0, 8, 9
    COLOR 15
    PRINT "***  HEX FILE CONVERTOR - LOAD MENU  ***"
    COLOR 7
    LOCATE 5, 15
    PRINT "1  -  Load Intel Hex"
    LOCATE 7, 15
    PRINT "2  -  Load Motorola S-Record"
    LOCATE 9, 15
    PRINT "3  -  Load RCA Cosmac"
    LOCATE 11, 15
    PRINT "4  -  Load Tektronix Hex"
    LOCATE 13, 15
    PRINT "5  -  Load ASCII Hex"
    LOCATE 15, 15
    PRINT "6  -  Load ASCII Binary"
    LOCATE 17, 15
    PRINT "7  -  Load Binary Image"
    LOCATE 19, 15
    PRINT "8  -  Load ASCII Text (Programmer and Emulator Format)"
    LOCATE 21, 13
    PRINT "Esc  -  Exit"
    LOCATE 25, 28
    COLOR 14
    PRINT "(C) 1994 Paul Stenning";
    COLOR 7
LoadMenuLoop:
    DO
        Key$ = INKEY$
    LOOP UNTIL Key$ <> ""
    SELECT CASE Key$
        CASE "1"
            GOSUB LoadFileName
            IntelLoad FileName$
            IF Loaded% = 1 THEN GOTO SaveMenu ELSE GOTO LoadMenu
        CASE "2"
            GOSUB LoadFileName
            SLoad FileName$
            IF Loaded% = 1 THEN GOTO SaveMenu ELSE GOTO LoadMenu
        CASE "3"
            GOSUB LoadFileName
            RCALoad FileName$
            IF Loaded% = 1 THEN GOTO SaveMenu ELSE GOTO LoadMenu
        CASE "4"
            GOSUB LoadFileName
            TekLoad FileName$
            IF Loaded% = 1 THEN GOTO SaveMenu ELSE GOTO LoadMenu
        CASE "5"
            GOSUB LoadFileName
            AsciiHexLoad FileName$
            IF Loaded% = 1 THEN GOTO SaveMenu ELSE GOTO LoadMenu
        CASE "6"
            GOSUB LoadFileName
            AsciiBinLoad FileName$
            IF Loaded% = 1 THEN GOTO SaveMenu ELSE GOTO LoadMenu
        CASE "7"
            GOSUB LoadFileName
            BinaryLoad FileName$
            IF Loaded% = 1 THEN GOTO SaveMenu ELSE GOTO LoadMenu
        CASE "8"
            GOSUB LoadFileName
            AsciiTextLoad FileName$
            IF Loaded% = 1 THEN GOTO SaveMenu ELSE GOTO LoadMenu
        CASE CHR$(27)
            GOTO Quit
    END SELECT
    GOTO LoadMenuLoop

SaveMenu:
    CLOSE
    DO UNTIL (MaxAddr& + 1) / 16 = INT((MaxAddr& + 1) / 16)
        MaxAddr& = MaxAddr& + 1
        PutByte MaxAddr&, 255
    LOOP
    ON ERROR GOTO 0
    CLS
    LOCATE 2, 20, 0, 8, 9
    COLOR 15
    PRINT "***  HEX FILE CONVERTOR - SAVE MENU  ***"
    COLOR 7
    LOCATE 5, 15
    PRINT "1  -  Save Intel Hex"
    LOCATE 7, 15
    PRINT "2  -  Save Motorola S-Record"
    LOCATE 9, 15
    PRINT "3  -  Save RCA Cosmac"
    LOCATE 11, 15
    PRINT "4  -  Save Tektronix Hex"
    LOCATE 13, 15
    PRINT "5  -  Save ASCII Hex"
    LOCATE 15, 15
    PRINT "6  -  Save ASCII Binary"
    LOCATE 17, 15
    PRINT "7  -  Save Binary Image"
    LOCATE 19, 15
    PRINT "8  -  Save ASCII Text (Programmer and Emulator Format)"
    LOCATE 21, 13
    PRINT "Esc  -  Return To Load Menu"
    LOCATE 25, 28
    COLOR 14
    PRINT "(C) 1994 Paul Stenning";
    COLOR 7
SaveMenuLoop:
    DO
        Key$ = INKEY$
    LOOP UNTIL Key$ <> ""
    SELECT CASE Key$
        CASE "1"
            GOSUB SaveFileName
            IntelSave FileName$, MaxAddr&
            GOTO SaveMenu
        CASE "2"
            GOSUB SaveFileName
            SSave FileName$, MaxAddr&
            GOTO SaveMenu
        CASE "3"
            GOSUB SaveFileName
            RCASave FileName$, MaxAddr&
            GOTO SaveMenu
        CASE "4"
            GOSUB SaveFileName
            TekSave FileName$, MaxAddr&
            GOTO SaveMenu
        CASE "5"
            GOSUB SaveFileName
            AsciiHexSave FileName$, MaxAddr&
            GOTO SaveMenu
        CASE "6"
            GOSUB SaveFileName
            AsciiBinSave FileName$, MaxAddr&
            GOTO SaveMenu
        CASE "7"
            GOSUB SaveFileName
            BinarySave FileName$, MaxAddr&
            GOTO SaveMenu
        CASE "8"
            GOSUB SaveFileName
            AsciiTextSave FileName$, MaxAddr&
            GOTO SaveMenu
        CASE CHR$(27)
            ERASE HexData1%, HexData2%
            REDIM SHARED HexData1%(0 TO 16383)
            REDIM SHARED HexData2%(0 TO 16383)
            MaxAddr& = 0
            GOTO LoadMenu
    END SELECT
    GOTO SaveMenuLoop
  
LoadFileName:
    CLS
    COLOR 14
    LOCATE 23, 25
    PRINT "Reading File Names - Please Wait";
    LOCATE 1, 1
    COLOR 7
    ON ERROR GOTO LoadError
    IF DOS >= 5 THEN
        SHELL "DIR *.HEX /-P /-W /ON > HEX-CONV.TMP"
    ELSE
        SHELL "DIR *.HEX > HEX-CONV.TMP"
    END IF
    OPEN "HEX-CONV.TMP" FOR INPUT AS #1
    Count% = 0
    DO UNTIL EOF(1)
        LINE INPUT #1, Temp$
        IF LEFT$(Temp$, 1) <> " " AND LEN(Temp$) <> 0 THEN
            PRINT LEFT$(Temp$, 8); "  ";
            Count% = Count% + 1
            IF Count% = 168 THEN
                LOCATE 23, 25
                COLOR 14
                PRINT " Press Any Key For Next Part "
                COLOR 7
                DO
                LOOP UNTIL INKEY$ <> ""
                Count% = 0
                CLS
            END IF
        END IF
    LOOP
    CLOSE #1
    KILL "HEX-CONV.TMP"
    LOCATE 23, 10
    COLOR 14
    INPUT "Enter Name Of Hex File To Load (.HEX Extension Assumed) ", FileName$
    IF FileName$ = "" THEN GOTO LoadMenu
    IF RIGHT$(FileName$, 4) <> ".HEX" THEN FileName$ = FileName$ + ".HEX"
    RETURN

SaveFileName:
    CLS
    LOCATE 2, 17
    INPUT "Enter File Name (Max 8 Characters) ", FileName$
    IF FileName$ = "" THEN GOTO SaveMenu
    IF LEN(FileName$) > 8 THEN Abort% = 1
    FileName$ = UCASE$(FileName$)
    Bad$ = " []^*?|\#:;<>,./'=+`" + CHR$(34)
    FOR Temp% = 1 TO LEN(Bad$)
        IF INSTR(FileName$, MID$(Bad$, Temp%, 1)) > 0 THEN
            Abort% = 1
            EXIT FOR
        END IF
    NEXT
    IF Abort% = 1 THEN
        LOCATE 22, 18
        COLOR 12
        PRINT "Invalid File Name - Press Any Key To Continue"
        BEEP
        DO
        LOOP UNTIL INKEY$ <> ""
        GOTO SaveMenu
    END IF
    ON ERROR GOTO SaveError
    IF RIGHT$(FileName$, 4) <> ".HEX" THEN
        FileName$ = FileName$ + ".HEX"
    END IF
    RETURN

LoadError:
    CLOSE #1
    LOCATE 23, 13
    COLOR 12
    PRINT "Error Loading Hex Data File - Press Any Key To Continue"
    COLOR 7
    BEEP
    DO
    LOOP UNTIL INKEY$ <> ""
    RESUME LoadMenu

SaveError:
    CLOSE #1
    LOCATE 23, 13
    COLOR 12
    PRINT "Error Saving Hex Data File - Press Any Key To Continue"
    COLOR 7
    BEEP
    DO
    LOOP UNTIL INKEY$ <> ""
    RESUME SaveMenu

Quit:
    LOCATE 23, 30
    COLOR 12
    PRINT " Exit To DOS [Y/N] ? "
    DO
        Key$ = UCASE$(INKEY$)
    LOOP UNTIL Key$ <> ""
    COLOR 7
    SELECT CASE Key$
        CASE "N", CHR$(27)
            LOCATE 23, 30
            PRINT SPACE$(20);
            GOTO LoadMenuLoop
        CASE "Y"
            CLOSE
            CLS
            PRINT
            PRINT "Goodbye!"
            PRINT
            END
    END SELECT
    GOTO Quit

WrongDos:
    PRINT
    PRINT "MS-DOS Version 3.00 or Higher Required"
    PRINT
    END

DosError:
    PRINT
    PRINT "Error Writing to Disk"
    PRINT
    END

Help:
    PRINT
    PRINT
    PRINT "Hex File Conversion Software"
    PRINT "(C) 1994 Paul Stenning"
    PRINT
    PRINT
    PRINT "EPROM <Options>"
    PRINT
    PRINT "Options"
    PRINT "        /?  =  Display this help information"
    PRINT
    PRINT "        No Other Options Currently Available"
    PRINT
    PRINT
    END

REM $STATIC
SUB AsciiBinLoad (FileName$)
SHARED Loaded%
Lne& = 0
Done& = 0
Address& = 0
DoneIt% = 0
Size& = FileSize&(FileName$)
OPEN FileName$ FOR INPUT AS #2
Percent 0, "Loading ASCII Binary Data File"
DO UNTIL EOF(2)
    IF INKEY$ = CHR$(27) THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - ESCAPE KEY PRESSED", 0, 0
        GOTO ABLDone
    END IF
    LINE INPUT #2, a$
    Lne& = Lne& + 1
    Done& = Done& + LEN(a$) + 2
    PC% = (Done& / Size&) * 100
    IF PC% > 100 THEN PC% = 100
    IF PC% = 0 THEN PC% = 1
    Percent PC%, ""
    IF Lne& = 1 AND LEFT$(a$, 1) = CHR$(2) THEN
        a$ = RIGHT$(a$, LEN(a$) - 1)
    END IF
    IF RIGHT$(a$, 1) = CHR$(3) THEN
        DoneIt% = 1
        a$ = LEFT$(a$, LEN(a$) - 1)
    END IF
    Count% = 1
ABL001:
    IF UCASE$(MID$(a$, Count%, 1)) <> "B" THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - FILE FORMAT ERROR IN LINE" + STR$(Lne&), 0, 0
        GOTO ABLDone
    END IF
    Count% = Count% + 1
    B% = 128: Temp% = 0
    FOR C% = Count% TO Count% + 7
        IF C% > LEN(a$) THEN
            Percent 101, ""
            Loaded% = 0
            Mistake 9, "ABORTED - FILE FORMAT ERROR IN LINE" + STR$(Lne&), 0, 0
            GOTO ABLDone
        END IF
        SELECT CASE UCASE$(MID$(a$, C%, 1))
            CASE "L", "N", "0"
                Temp% = Temp% + 0
            CASE "H", "P", "1"
                Temp% = Temp% + B%
            CASE ELSE
                Percent 101, ""
                Loaded% = 0
                Mistake 9, "ABORTED - FILE FORMAT ERROR IN LINE" + STR$(Lne&), 0, 0
                GOTO ABLDone
            END SELECT
        B% = B% / 2
        NEXT
    PutByte Address&, Temp%
    Address& = Address& + 1
    Count% = Count% + 8
    IF Count% > LEN(a$) OR UCASE$(MID$(a$, Count%, 1)) <> "F" THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - FILE FORMAT ERROR IN LINE" + STR$(Lne&), 0, 0
        GOTO ABLDone
    END IF
    Count% = Count% + 1
    DO UNTIL Count% > LEN(a$) OR MID$(a$, Count%, 1) <> " "
        Count% = Count% + 1
        LOOP
    IF Count% > LEN(a$) THEN
        GOTO ABL002
    ELSE
        GOTO ABL001
    END IF
ABL002:
LOOP

ABLDone:
Percent 101, ""
CLOSE #2
END SUB

SUB AsciiBinSave (FileName$, MaxAddr&)
OPEN FileName$ FOR OUTPUT AS #2
Percent 0, "Saving ASCII Binary Data File"
PRINT #2, CHR$(2);
FOR Addr& = 0 TO MaxAddr& - 3 STEP 4
    IF INKEY$ = CHR$(27) THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - ESCAPE KEY PRESSED", 0, 0
        GOTO ABSDone
    END IF
    PC% = ((Addr& + 3) / MaxAddr&) * 100
    IF PC% = 0 THEN PC% = 1
    Percent PC%, ""
    FOR Count% = 0 TO 3
        Temp$ = "B"
        Temp% = GetByte%(Addr& + Count%)
        B% = 128
        FOR C% = 1 TO 8
            IF (Temp% AND B%) <> 0 THEN
                Temp$ = Temp$ + "1"
            ELSE
                Temp$ = Temp$ + "0"
            END IF
            B% = B% / 2
            NEXT
        Temp$ = Temp$ + "F"
        IF Count% <> 3 THEN Temp$ = Temp$ + " "
        PRINT #2, Temp$;
        NEXT
    IF Addr& + 3 <> MaxAddr& THEN
        PRINT #2,
    ELSE
        PRINT #2, CHR$(3)
    END IF
    NEXT
PRINT #2, CHR$(26)
ABSDone:
Percent 101, ""
CLOSE #2
END SUB

SUB AsciiHexLoad (FileName$)
SHARED Loaded%
Lne& = 1
Done& = 0
Sum& = 0
Size& = FileSize&(FileName$)
OPEN FileName$ FOR INPUT AS #2
Percent 0, "Loading ASCII Hex Data File"
LINE INPUT #2, a$
a$ = RTRIM$(LTRIM$(a$))
a$ = RIGHT$(a$, 7)
IF RIGHT$(a$, 1) <> "," OR LEFT$(a$, 1) <> "$" OR LEN(a$) <> 7 THEN
    Percent 101, ""
    Loaded% = 0
    Mistake 9, "ABORTED - FILE FORMAT ERROR IN LINE" + STR$(Lne&), 0, 0
    GOTO AHLDone
END IF
Address& = VAL("&h" + MID$(a$, 3, 4))
IF Address& < 0 THEN Address& = Address& + 65536
DO UNTIL EOF(2)
    IF INKEY$ = CHR$(27) THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - ESCAPE KEY PRESSED", 0, 0
        GOTO AHLDone
    END IF
    LINE INPUT #2, a$
    Lne& = Lne& + 1
    Done& = Done& + LEN(a$) + 2
    PC% = (Done& / Size&) * 100
    IF PC% > 100 THEN PC% = 100
    IF PC% = 0 THEN PC% = 1
    Percent PC%, ""
    IF LEFT$(a$, 1) = "$" THEN GOTO AHSum
    IF LEN(a$) / 3 <> INT(LEN(a$) / 3) AND RIGHT$(a$, 1) <> CHR$(3) THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - FILE FORMAT ERROR IN LINE" + STR$(Lne&), 0, 0
        GOTO AHLDone
    END IF
    bytes% = LEN(a$) / 3
    FOR Count% = 0 TO bytes% - 1
        IF MID$(a$, (Count% * 3) + 1, 1) = CHR$(3) THEN GOTO AHSum
        Temp% = VAL("&h" + MID$(a$, (Count% * 3) + 1, 2))
        Sum& = Sum& + Temp%
        PutByte Address&, Temp%
        Address& = Address& + 1
        NEXT
    LOOP
AHSum:
IF LEFT$(a$, 1) <> "$" THEN LINE INPUT a$: Lne& = Lne& + 1
IF RIGHT$(a$, 1) <> "," THEN
    Percent 101, ""
    Loaded% = 0
    Mistake 9, "ABORTED - FILE FORMAT ERROR IN LINE" + STR$(Lne&), 0, 0
    GOTO AHLDone
END IF
Sum& = LoWord%(Sum&)
IF VAL("&h" + MID$(a$, 3, 4)) <> Sum& THEN
    Percent 101, ""
    Loaded% = 0
    Mistake 9, "ABORTED - CHECKSUM ERROR", 0, 0
END IF

AHLDone:
Percent 101, ""
CLOSE #2
END SUB

SUB AsciiHexSave (FileName$, MaxAddr&)
OPEN FileName$ FOR OUTPUT AS #2
Percent 0, "Saving ASCII Hex Data File"
Sum& = 0
PRINT #2, CHR$(2); CHR$(3); "$A0000,"
FOR Addr& = 0 TO MaxAddr& - 15 STEP 16
    IF INKEY$ = CHR$(27) THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - ESCAPE KEY PRESSED", 0, 0
        GOTO AHSDone
    END IF
    PC% = ((Addr& + 15) / MaxAddr&) * 100
    IF PC% = 0 THEN PC% = 1
    Percent PC%, ""
    FOR Count% = 0 TO 15
        Sum& = Sum& + GetByte%(Addr& + Count%)
        Temp$ = HEX$(GetByte%(Addr& + Count%))
        DO UNTIL LEN(Temp$) >= 2: Temp$ = "0" + Temp$: LOOP
        PRINT #2, Temp$; " ";
        NEXT
    PRINT #2,
    NEXT
Sum% = LoWord%(Sum&)
Temp$ = HEX$(Sum%)
DO UNTIL LEN(Temp$) >= 4: Temp$ = "0" + Temp$: LOOP
PRINT #2, "$S"; Temp$; ","
PRINT #2, CHR$(26)
AHSDone:
Percent 101, ""
CLOSE #2
END SUB

SUB AsciiTextLoad (FileName$)
SHARED Loaded%
Lne& = 0
Done& = 0
Address& = 0
Size& = FileSize&(FileName$)
OPEN FileName$ FOR INPUT AS #2
Percent 0, "Loading ASCII Text Data File"
DO UNTIL EOF(2)
    IF INKEY$ = CHR$(27) THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - ESCAPE KEY PRESSED", 0, 0
        GOTO ATLDone
    END IF
    LINE INPUT #2, a$
    Lne& = Lne& + 1
    Done& = Done& + LEN(a$) + 2
    PC% = (Done& / Size&) * 100
    IF PC% > 100 THEN PC% = 100
    IF PC% = 0 THEN PC% = 1
    Percent PC%, ""
    a$ = LTRIM$(RTRIM$(a$))
    IF LEN(a$) < 7 AND Lne& < 5 THEN GOTO ATL002
    Address& = VAL("&h" + LEFT$(a$, 4))
    IF MID$(a$, 5, 1) <> " " THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - FILE FORMAT ERROR IN LINE" + STR$(Lne&), 0, 0
        GOTO ATLDone
    END IF
    Count% = 6
ATL001:
    DO UNTIL MID$(a$, Count%, 1) <> " " OR Count% >= LEN(a$)
        Count% = Count% + 1
    LOOP
    IF Count% >= LEN(a$) THEN GOTO ATL002
    PutByte Address&, VAL("&h" + MID$(a$, Count%, 2))
    Address& = Address& + 1
    Count% = Count% + 2
    IF Count% >= LEN(a$) THEN GOTO ATL002
    IF MID$(a$, Count%, 1) <> " " THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - FILE FORMAT ERROR IN LINE" + STR$(Lne&), 0, 0
        GOTO ATLDone
    END IF
    Count% = Count% + 1
    GOTO ATL001
ATL002:
LOOP

ATLDone:
Percent 101, ""
CLOSE #2
END SUB

SUB AsciiTextSave (FileName$, MaxAddr&)
OPEN FileName$ FOR OUTPUT AS #2
Percent 0, "Saving ASCII Text Data File"
FOR Addr& = 0 TO MaxAddr& - 15 STEP 16
    IF INKEY$ = CHR$(27) THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - ESCAPE KEY PRESSED", 0, 0
        GOTO ATSDone
    END IF
    PC% = ((Addr& + 15) / MaxAddr&) * 100
    IF PC% = 0 THEN PC% = 1
    Percent PC%, ""
    Temp$ = HEX$(Addr&)
    DO UNTIL LEN(Temp$) >= 4: Temp$ = "0" + Temp$: LOOP
    PRINT #2, Temp$; "   ";
    FOR Count% = 0 TO 15
        Temp$ = HEX$(GetByte%(Addr& + Count%))
        DO UNTIL LEN(Temp$) >= 2: Temp$ = "0" + Temp$: LOOP
        PRINT #2, " "; Temp$;
        NEXT
    PRINT #2,
    NEXT
PRINT #2, CHR$(26)
ATSDone:
Percent 101, ""
CLOSE #2
END SUB

SUB BinaryLoad (FileName$)
SHARED Loaded%
Done& = 0
Address& = 0
Size& = FileSize&(FileName$)
OPEN FileName$ FOR BINARY AS #2
Percent 0, "Loading Binary Image File"
DO UNTIL EOF(2) OR Address& > 65535
    IF INKEY$ = CHR$(27) THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - ESCAPE KEY PRESSED", 0, 0
        GOTO BinDone
    END IF
    SEEK #2, Address& + 1
    a$ = INPUT$(1, #2)
    IF a$ <> "" THEN PutByte Address&, ASC(a$)
    Address& = Address& + 1
    IF Address& > 65535 THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - FILE LARGER THEN 64K", 0, 0
        GOTO BinDone
    END IF
    PC% = (Address& / Size&) * 100
    IF PC% = 0 THEN PC% = 1
    IF PC% > 100 THEN PC% = 100
    Percent PC%, ""
LOOP
Percent 101, ""
BinDone:
CLOSE #2
END SUB

SUB BinarySave (FileName$, MaxAddr&)
IF FileSize&(FileName$) <> 0 THEN KILL FileName$
OPEN FileName$ FOR BINARY AS #2
Percent 0, "Saving Binary Image File"
FOR Addr& = 0 TO MaxAddr&
    IF INKEY$ = CHR$(27) THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - ESCAPE KEY PRESSED", 0, 0
        GOTO BSDone
    END IF
    PC% = (Addr& / MaxAddr&) * 100
    IF PC% = 0 THEN PC% = 1
    Percent PC%, ""
    Temp$ = CHR$(GetByte%(Addr&))
    PUT #2, Addr& + 1, Temp$
    NEXT
BSDone:
Percent 101, ""
CLOSE #2
END SUB

FUNCTION FileSize& (FileSpec$)
SHELL "DIR " + FileSpec$ + " > HEX-CONV.TMP"

FileTemp$ = LEFT$(FileSpec$, LEN(FileSpec$) - 4)
FileTemp$ = FileTemp$ + SPACE$(13 - (LEN(FileSpec$)))
FileTemp$ = FileTemp$ + RIGHT$(FileSpec$, 3)

OPEN "HEX-CONV.TMP" FOR INPUT AS #3
DO UNTIL EOF(3)
    LINE INPUT #3, Temp$
    IF UCASE$(LEFT$(Temp$, 12)) = UCASE$(FileTemp$) THEN
        Temp2$ = MID$(Temp$, 15, 12)
    END IF
LOOP

CLOSE #3
KILL "HEX-CONV.TMP"

IF DOS < 6.2 THEN
    Temp2$ = LEFT$(Temp2$, LEN(Temp2$) - 4)
END IF

Temp2$ = LTRIM$(RTRIM$(Temp2$))
Temp3$ = ""
FOR Temp% = 1 TO LEN(Temp2$)
    IF MID$(Temp2$, Temp%, 1) <> "," THEN Temp3$ = Temp3$ + MID$(Temp2$, Temp%, 1)
NEXT

FileSize& = VAL(Temp3$)
END FUNCTION

FUNCTION GetByte% (Address&)
IF Address& > 65535 OR Address& < 0 THEN EXIT FUNCTION
Addr& = Address&
IF Addr& > 32767 THEN
    Addr& = Addr& - 32768
    IF Addr& > 16383 THEN
        Addr& = Addr& - 16384
        DataTemp& = HexData2%(Addr&)
        Value% = HiByte%(DataTemp&)
    ELSE
        DataTemp& = HexData2%(Addr&)
        Value% = LoByte%(DataTemp&)
    END IF
ELSE
    IF Addr& > 16383 THEN
        Addr& = Addr& - 16384
        DataTemp& = HexData1%(Addr&)
        Value% = HiByte%(DataTemp&)
    ELSE
        DataTemp& = HexData1%(Addr&)
        Value% = LoByte%(DataTemp&)
    END IF
END IF
GetByte% = 255 - Value%
END FUNCTION

FUNCTION HiByte% (Number&)
Temp% = INT(Number& / 256)
IF Temp% > 255 THEN Temp% = Temp% - 256
IF Temp% < 0 THEN Temp% = Temp% + 256
HiByte% = Temp%
END FUNCTION

SUB IntelLoad (FileName$)
SHARED Loaded%
Lne& = 0
Done& = 0
Size& = FileSize&(FileName$)
OPEN FileName$ FOR INPUT AS #2
Percent 0, "Loading Intel Hex Data File"
DO UNTIL EOF(2)
    IF INKEY$ = CHR$(27) THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - ESCAPE KEY PRESSED", 0, 0
        GOTO ILDone
    END IF
    LINE INPUT #2, a$
    Lne& = Lne& + 1
    Done& = Done& + LEN(a$) + 2
    PC% = (Done& / Size&) * 100
    IF PC% > 100 THEN PC% = 100
    IF PC% = 0 THEN PC% = 1
    Percent PC%, ""
    a$ = LTRIM$(RTRIM$(a$))
    IF LEFT$(a$, 1) <> ":" THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - FILE FORMAT ERROR IN LINE" + STR$(Lne&), 0, 0
        GOTO ILDone
    END IF
    bytes% = VAL("&h" + MID$(a$, 2, 2))
    IF LEN(a$) <> bytes% * 2 + 11 THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - FILE FORMAT ERROR IN LINE" + STR$(Lne&), 0, 0
        GOTO ILDone
    END IF
    Sum& = bytes%
    Address& = VAL("&h" + MID$(a$, 4, 4))
    Sum& = Sum& + LoByte%(Address&) + HiByte%(Address&)
    IF Address& < 0 THEN Address& = Address& + 65536
    IF MID$(a$, 8, 2) = "01" OR bytes% = 0 THEN GOTO ILDone
    Sum& = Sum& + VAL("&h" + MID$(a$, 8, 2))
    FOR Count% = 0 TO (bytes% - 1)
        Temp% = VAL("&h" + MID$(a$, 10 + Count% * 2, 2))
        Sum& = Sum& + Temp%
        PutByte Address& + Count%, Temp%
    NEXT
    Sum% = LoByte%(Sum&)
    IF Sum% = 0 THEN Sum% = 256
    IF Sum% + VAL("&h" + RIGHT$(a$, 2)) <> 256 THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - CHECKSUM ERROR IN LINE" + STR$(Lne&), 0, 0
        GOTO ILDone
    END IF
LOOP
ILDone:
Percent 101, ""
CLOSE #2
END SUB

SUB IntelSave (FileName$, MaxAddr&)
OPEN FileName$ FOR OUTPUT AS #2
Percent 0, "Saving Intel Hex Data File"
FOR Addr& = 0 TO MaxAddr& - 15 STEP 16
    IF INKEY$ = CHR$(27) THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - ESCAPE KEY PRESSED", 0, 0
        GOTO ISDone
    END IF
    PC% = ((Addr& + 15) / MaxAddr&) * 100
    IF PC% = 0 THEN PC% = 1
    Percent PC%, ""
    Temp$ = HEX$(Addr&)
    DO UNTIL LEN(Temp$) >= 4: Temp$ = "0" + Temp$: LOOP
    PRINT #2, ":10"; Temp$; "00";
    Sum& = 16 + LoByte%(Addr&) + HiByte%(Addr&)
    FOR Count% = 0 TO 15
        Temp$ = HEX$(GetByte%(Addr& + Count%))
        Sum& = Sum& + GetByte%(Addr& + Count%)
        DO UNTIL LEN(Temp$) >= 2: Temp$ = "0" + Temp$: LOOP
        PRINT #2, Temp$;
        NEXT
    Sum% = LoByte%(Sum&)
    IF Sum% = 0 THEN Sum% = 256
    Sum% = 256 - Sum%
    Temp$ = HEX$(Sum%)
    DO UNTIL LEN(Temp$) >= 2: Temp$ = "0" + Temp$: LOOP
    PRINT #2, Temp$
    NEXT
PRINT #2, ":00000001FF"
PRINT #2, CHR$(26)
ISDone:
Percent 101, ""
CLOSE #2
END SUB

FUNCTION LoByte% (Number&)
Temp% = Number& MOD 256
IF Temp% > 255 THEN Temp% = Temp% - 256
IF Temp% < 0 THEN Temp% = Temp% + 256
LoByte% = Temp%
END FUNCTION

FUNCTION LoWord% (Number&)
Temp& = Number& MOD 65536
IF Temp& > 32767 THEN Temp& = Temp& - 65536
LoWord% = Temp&
END FUNCTION

SUB Mistake (x1%, Message$, x2%, x3%)
REM - x1%, x2% and x3% are not used
CLS
COLOR 12
LOCATE 9, 15
PRINT "ͻ"
LOCATE 10, 15
PRINT "                                                 "
LOCATE 11, 15
PRINT "                                                 "
LOCATE 11, 40 - (LEN(Message$) / 2)
PRINT Message$
LOCATE 12, 15
PRINT "                                                 "
LOCATE 13, 15
PRINT "        PRESS ANY KEY TO RETURN TO MENU          "
LOCATE 14, 15
PRINT "                                                 "
LOCATE 15, 15
PRINT "ͼ"
BEEP
DO: LOOP UNTIL INKEY$ <> ""
COLOR 7
END SUB

SUB Percent (Value%, Message$)
SELECT CASE Value%
CASE 0
    CLS
    COLOR 7
    LOCATE 9, 15
    PRINT "ͻ"
    LOCATE 10, 15
    PRINT "                                                 "
    LOCATE 10, 40 - (LEN(Message$) / 2)
    PRINT Message$
    LOCATE 11, 15
    PRINT "                                                 "
    LOCATE 12, 15
    PRINT "   Ŀ   "
    LOCATE 13, 15
    PRINT "                                               "
    LOCATE 14, 15
    PRINT "      "
    LOCATE 15, 15
    PRINT "ͼ"
CASE 1 TO 100
    LOCATE 13, 20
    FOR Temp% = 0 TO Value% / 2.5
        PRINT "";
    NEXT
CASE IS > 100
    CLS
END SELECT
END SUB

SUB PutByte (Address&, Value%)
SHARED MaxAddr&
IF Address& > 65535 OR Address& < 0 THEN EXIT SUB
IF Value% > 255 OR Value% < 0 THEN EXIT SUB
IF Address& > MaxAddr& THEN MaxAddr& = Address&
Value& = Value%
Addr& = Address&
Value& = 255 - Value&
IF Addr& > 32767 THEN
    Addr& = Addr& - 32768
    IF Addr& > 16383 THEN
        Addr& = Addr& - 16384
        DataTemp& = HexData2%(Addr&)
        Lo& = LoByte%(DataTemp&)
        Temp& = (Value& * 256) + Lo&
    ELSE
        DataTemp& = HexData2%(Addr&)
        Hi& = HiByte%(DataTemp&)
        Temp& = (Hi& * 256) + Value&
    END IF
    IF Temp& > 32767 THEN Temp& = Temp& - 65536
    HexData2%(Addr&) = Temp&
ELSE
    IF Addr& > 16383 THEN
        Addr& = Addr& - 16384
        DataTemp& = HexData1%(Addr&)
        Lo& = LoByte%(DataTemp&)
        Temp& = (Value& * 256) + Lo&
    ELSE
        DataTemp& = HexData1%(Addr&)
        Hi% = HiByte%(DataTemp&)
        Temp& = (Hi& * 256) + Value&
    END IF
    IF Temp& > 32767 THEN Temp& = Temp& - 65536
    HexData1%(Addr&) = Temp&
END IF
END SUB

SUB RCALoad (FileName$)
SHARED Loaded%
Addr% = 1
Lne& = 0
Done& = 0
Size& = FileSize&(FileName$)
OPEN FileName$ FOR INPUT AS #2
Percent 0, "Loading RCA Cosmac Data File"
IF NOT EOF(2) THEN
    LINE INPUT #2, a$
    a$ = LTRIM$(RTRIM$(a$))
    IF a$ <> "!M" THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - FILE FORMAT ERROR", 0, 0
        GOTO RLDone
    END IF
END IF
DO UNTIL EOF(2)
    IF INKEY$ = CHR$(27) THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - ESCAPE KEY PRESSED", 0, 0
        GOTO RLDone
    END IF
    LINE INPUT #2, a$
    Lne& = Lne& + 1
    Done& = Done& + LEN(a$) + 2
    PC% = (Done& / Size&) * 100
    IF PC% > 100 THEN PC% = 100
    IF PC% = 0 THEN PC% = 1
    Percent PC%, ""
    a$ = LTRIM$(RTRIM$(a$))
    IF Addr% = 1 THEN
        Address& = VAL("&h" + LEFT$(a$, 4))
        IF Address& < 0 THEN Address& = Address& + 65536
        Poss% = 6
        IF MID$(a$, 5, 1) <> " " THEN
            Percent 101, ""
            Loaded% = 0
            Mistake 9, "ABORTED - FILE FORMAT ERROR IN LINE" + STR$(Lne&), 0, 0
            GOTO RLDone
        END IF
    ELSE
        Poss% = 1
        IF MID$(a$, 5, 1) = " " THEN
            Percent 101, ""
            Loaded% = 0
            Mistake 9, "ABORTED - FILE FORMAT ERROR IN LINE" + STR$(Lne&), 0, 0
            GOTO RLDone
        END IF
    END IF
    Lenn% = LEN(a$) - 2
    IF RIGHT$(a$, 1) <> ";" AND RIGHT$(a$, 1) <> "," THEN Lenn% = Lenn% + 1
    FOR Count% = Poss% TO Lenn% STEP 2
        Temp% = VAL("&h" + MID$(a$, Count%, 2))
        PutByte Address&, Temp%
        Address& = Address& + 1
    NEXT
    SELECT CASE RIGHT$(a$, 1)
        CASE ";": Addr% = 1
        CASE ",": Addr% = 0
        CASE "0" TO "9", "A" TO "F": GOTO RLDone
        CASE ELSE
            Percent 101, ""
            Loaded% = 0
            Mistake 9, "ABORTED - FILE FORMAT ERROR IN LINE" + STR$(Lne&), 0, 0
            GOTO RLDone
        END SELECT
LOOP
RLDone:
Percent 101, ""
CLOSE #2
END SUB

SUB RCASave (FileName$, MaxAddr&)
OPEN FileName$ FOR OUTPUT AS #2
Percent 0, "Saving RCA Cosmac Data File"
PRINT #2, "!M"
FOR Addr& = 0 TO MaxAddr& - 15 STEP 16
    IF INKEY$ = CHR$(27) THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - ESCAPE KEY PRESSED", 0, 0
        GOTO RSDone
    END IF
    PC% = ((Addr& + 15) / MaxAddr&) * 100
    IF PC% = 0 THEN PC% = 1
    Percent PC%, ""
    Temp$ = HEX$(Addr&)
    DO UNTIL LEN(Temp$) >= 4: Temp$ = "0" + Temp$: LOOP
    PRINT #2, Temp$; " ";
    FOR Count% = 0 TO 15
        Temp$ = HEX$(GetByte%(Addr& + Count%))
        DO UNTIL LEN(Temp$) >= 2: Temp$ = "0" + Temp$: LOOP
        PRINT #2, Temp$;
        NEXT
    IF Addr& + 15 <> MaxAddr& THEN
        PRINT #2, ";"
    ELSE
        PRINT #2,
    END IF
    NEXT
PRINT #2, CHR$(26)
RSDone:
Percent 101, ""
CLOSE #2

END SUB

SUB SLoad (FileName$)
SHARED Loaded%
Lne& = 0
Done& = 0
Size& = FileSize&(FileName$)
OPEN FileName$ FOR INPUT AS #2
Percent 0, "Loading Motorola S Record Data File"
DO UNTIL EOF(2)
    IF INKEY$ = CHR$(27) THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - ESCAPE KEY PRESSED", 0, 0
        GOTO SLDone
    END IF
    LINE INPUT #2, a$
    Lne& = Lne& + 1
    Done& = Done& + LEN(a$) + 2
    PC% = (Done& / Size&) * 100
    IF PC% > 100 THEN PC% = 100
    IF PC% = 0 THEN PC% = 1
    Percent PC%, ""
    a$ = LTRIM$(RTRIM$(a$))
    IF LEFT$(a$, 1) <> "S" THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - FILE FORMAT ERROR IN LINE" + STR$(Lne&), 0, 0
        GOTO SLDone
    END IF
    SELECT CASE MID$(a$, 2, 1)
        CASE "9": GOTO SLDone
        CASE "1": AddrChr% = 0
        CASE "2": AddrChr% = 2
        CASE ELSE
            Loaded% = 0
            Mistake 9, "ABORTED - BAD RECORD TYPE IN LINE" + STR$(Lne&), 0, 0
            GOTO SLDone
            END SELECT
    bytes% = VAL("&h" + MID$(a$, 3, 2))
    IF LEN(a$) <> bytes% * 2 + 4 THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - FILE FORMAT ERROR IN LINE" + STR$(Lne&), 0, 0
        GOTO SLDone
    END IF
    Sum& = bytes%
    IF AddrChr% = 2 AND MID$(a$, 5, 2) <> "00" THEN
        Loaded% = 0
        Mistake 9, "ABORTED - INVALID ADDRESS IN LINE" + STR$(Lne&), 0, 0
        GOTO SLDone
    END IF
    Address& = VAL("&h" + MID$(a$, 5 + AddrChr%, 4))
    Sum& = Sum& + LoByte%(Address&) + HiByte%(Address&)
    IF Address& < 0 THEN Address& = Address& + 65536
    IF AddrChr% = 2 THEN bytes% = bytes% - 1
    FOR Count% = 0 TO (bytes% - 4)
        Temp% = VAL("&h" + MID$(a$, 9 + AddChr% + (Count% * 2), 2))
        Sum& = Sum& + Temp%
        PutByte Address& + Count%, Temp%
    NEXT
    Sum% = LoByte%(Sum&)
    IF Sum% + VAL("&h" + RIGHT$(a$, 2)) <> 255 THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - CHECKSUM ERROR IN LINE" + STR$(Lne&), 0, 0
        GOTO SLDone
    END IF
LOOP
SLDone:
Percent 101, ""
CLOSE #2

END SUB

SUB SSave (FileName$, MaxAddr&)
OPEN FileName$ FOR OUTPUT AS #2
Percent 0, "Saving Motorola S Record Data File"
FOR Addr& = 0 TO MaxAddr& - 15 STEP 16
    IF INKEY$ = CHR$(27) THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - ESCAPE KEY PRESSED", 0, 0
        GOTO SSDone
    END IF
    PC% = ((Addr& + 15) / MaxAddr&) * 100
    IF PC% = 0 THEN PC% = 1
    Percent PC%, ""
    Temp$ = HEX$(Addr&)
    DO UNTIL LEN(Temp$) >= 4: Temp$ = "0" + Temp$: LOOP
    PRINT #2, "S113"; Temp$;
    Sum& = 19 + LoByte%(Addr&) + HiByte%(Addr&)
    FOR Count% = 0 TO 15
        Temp$ = HEX$(GetByte%(Addr& + Count%))
        Sum& = Sum& + GetByte%(Addr& + Count%)
        DO UNTIL LEN(Temp$) >= 2: Temp$ = "0" + Temp$: LOOP
        PRINT #2, Temp$;
        NEXT
    Sum% = LoByte%(Sum&)
    Sum% = 255 - Sum%
    Temp$ = HEX$(Sum%)
    DO UNTIL LEN(Temp$) >= 2: Temp$ = "0" + Temp$: LOOP
    PRINT #2, Temp$
    NEXT
PRINT #2, "S9030000FC"
PRINT #2, CHR$(26)
SSDone:
Percent 101, ""
CLOSE #2
END SUB

SUB TekLoad (FileName$)
SHARED Loaded%
Lne& = 0
Done& = 0
Size& = FileSize&(FileName$)
OPEN FileName$ FOR INPUT AS #2
Percent 0, "Loading Tektronix Hex Data File"
DO UNTIL EOF(2)
    IF INKEY$ = CHR$(27) THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - ESCAPE KEY PRESSED", 0, 0
        GOTO TLDone
    END IF
    LINE INPUT #2, a$
    Lne& = Lne& + 1
    Done& = Done& + LEN(a$) + 2
    PC% = (Done& / Size&) * 100
    IF PC% > 100 THEN PC% = 100
    IF PC% = 0 THEN PC% = 1
    Percent PC%, ""
    a$ = LTRIM$(RTRIM$(a$))
    IF LEFT$(a$, 1) <> "/" THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - FILE FORMAT ERROR IN LINE" + STR$(Lne&), 0, 0
        GOTO TLDone
    END IF
    Address& = VAL("&h" + MID$(a$, 2, 4))
    IF Address& < 0 THEN Address& = Address& + 65536
    bytes% = VAL("&h" + MID$(a$, 6, 2))
    Sum& = 0
    FOR Temp% = 2 TO 7: Sum& = Sum& + VAL("&h" + MID$(a$, Temp%, 1)): NEXT
    Sum% = LoByte%(Sum&)
    IF Sum% <> VAL("&h" + MID$(a$, 8, 2)) THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - CHECKSUM ERROR IN LINE" + STR$(Lne&), 0, 0
        GOTO TLDone
    END IF
    IF bytes% = 0 THEN GOTO TLDone
    IF LEN(a$) <> bytes% * 2 + 11 THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - FILE FORMAT ERROR IN LINE" + STR$(Lne&), 0, 0
        GOTO TLDone
    END IF
    Sum& = 0
    FOR Count% = 0 TO (bytes% - 1)
        Temp% = VAL("&h" + MID$(a$, 10 + Count% * 2, 2))
        Sum& = Sum& + VAL("&h" + MID$(a$, 10 + Count% * 2, 1))
        Sum& = Sum& + VAL("&h" + MID$(a$, 11 + Count% * 2, 1))
        PutByte Address& + Count%, Temp%
    NEXT
    Sum% = LoByte%(Sum&)
    IF Sum% <> VAL("&h" + RIGHT$(a$, 2)) THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - CHECKSUM ERROR IN LINE" + STR$(Lne&), 0, 0
        GOTO TLDone
    END IF
LOOP
TLDone:
Percent 101, ""
CLOSE #2
END SUB

SUB TekSave (FileName$, MaxAddr&)
OPEN FileName$ FOR OUTPUT AS #2
Percent 0, "Saving Tektronix Hex Data File"
FOR Addr& = 0 TO MaxAddr& - 15 STEP 16
    IF INKEY$ = CHR$(27) THEN
        Percent 101, ""
        Loaded% = 0
        Mistake 9, "ABORTED - ESCAPE KEY PRESSED", 0, 0
        GOTO TSDone
    END IF
    PC% = ((Addr& + 15) / MaxAddr&) * 100
    IF PC% = 0 THEN PC% = 1
    Percent PC%, ""
    Temp$ = HEX$(Addr&)
    DO UNTIL LEN(Temp$) >= 4: Temp$ = "0" + Temp$: LOOP
    PRINT #2, "/"; Temp$; "10";
    Sum& = 1
    FOR Count% = 1 TO 4
        Sum& = Sum& + VAL("&h" + MID$(Temp$, Count%, 1))
        NEXT
    Sum% = LoByte%(Sum&)
    Temp$ = HEX$(Sum%)
    DO UNTIL LEN(Temp$) >= 2: Temp$ = "0" + Temp$: LOOP
    PRINT #2, Temp$;
    Sum& = 0
    FOR Count% = 0 TO 15
        Temp$ = HEX$(GetByte%(Addr& + Count%))
        DO UNTIL LEN(Temp$) >= 2: Temp$ = "0" + Temp$: LOOP
        Sum& = Sum& + VAL("&h" + LEFT$(Temp$, 1)) + VAL("&h" + RIGHT$(Temp$, 1))
        PRINT #2, Temp$;
        NEXT
    Sum% = LoByte%(Sum&)
    Temp$ = HEX$(Sum%)
    DO UNTIL LEN(Temp$) >= 2: Temp$ = "0" + Temp$: LOOP
    PRINT #2, Temp$
    NEXT
PRINT #2, "/00000000"
PRINT #2, CHR$(26)
TSDone:
Percent 101, ""
CLOSE #2
END SUB

