REM     *****         EPROM Programmer Control Software        *****
REM     *****              (C) 1994 Paul Stenning              *****
REM
REM     *****     Source Code for Microsoft QuickBASIC V4.5    *****
REM     *****         and QBASIC (MS-DOS 5.0 and later)        *****
REM
REM
REM     *****        See README.TXT For Use Restrictions       *****


REM Version 1.00 - 21/07/94
REM Version 1.10 - 27/12/98  --  Patch to work with Windows 95

Init:
    SCREEN 0
    WIDTH 80
    COLOR 7, 0
    CLS
    IF LEFT$(COMMAND$, 2) = "/?" THEN GOTO Help
    PRINT
    PRINT "EPROM Programmer Software Loading - Please Wait"
    ValidData% = 0
    ON ERROR GOTO DosError
    Temp% = 0
    SHELL "VER > EPROM.TMP"
    OPEN "EPROM.TMP" FOR INPUT AS #2
    DO UNTIL EOF(2) OR Temp% = 1
        LINE INPUT #2, Temp$
        Temp$ = LTRIM$(RTRIM$(Temp$))
        IF LEN(Temp$) > 0 THEN
            DOS = VAL(RIGHT$(Temp$, 5))
            IF DOS < 1 THEN DOS = 950
            Temp% = 1
        END IF
    LOOP
    CLOSE #2
    KILL "EPROM.TMP"
    IF DOS < 3 THEN GOTO WrongDos
    ON ERROR GOTO 0
    GOSUB OpenCom
    Device$ = ""

Top:
    CLS
    LOCATE 3, 15, 0, 8, 9
    COLOR 15
    PRINT "***  EPROM PROGRAMMER - DEVICE SELECTION MENU  ***"
    COLOR 7
    LOCATE 8, 30
    PRINT "1  -  2764"
    LOCATE 10, 30
    PRINT "2  -  27128"
    LOCATE 12, 30
    PRINT "3  -  27256"
    LOCATE 14, 30
    PRINT "4  -  27512"
    LOCATE 16, 28
    IF Device$ = "" THEN
        PRINT "Esc  -  Exit"
    ELSE
        PRINT "Esc  -  No Change"
        COLOR 11
        LOCATE 20, 22
        PRINT "EPROM Type Currently Selected = "; Device$
    END IF
    LOCATE 25, 28
    COLOR 14
    PRINT "(C) 1994 Paul Stenning";
    COLOR 7
TopLoop:
    DO
        Key$ = INKEY$
    LOOP UNTIL Key$ <> ""
    SELECT CASE Key$
        CASE "1"
            Device$ = "2764": MaxAddr& = 8191
        CASE "2"
            Device$ = "27128": MaxAddr& = 16383
        CASE "3"
            Device$ = "27256": MaxAddr& = 32767
        CASE "4"
            Device$ = "27512": MaxAddr& = 65535
        CASE CHR$(27)
            IF Device$ = "" THEN
                GOSUB Quit
            END IF
    END SELECT
    IF Device$ = "" THEN GOTO TopLoop

MainMenu:
    ON ERROR GOTO 0
    CLS
    LOCATE 2, 21
    COLOR 15
    PRINT "***  EPROM PROGRAMMER - MAIN MENU  ***"
    COLOR 7
    LOCATE 5, 15
    PRINT "1  -  Read EPROM And Save Data To Disk"
    LOCATE 7, 15
    PRINT "2  -  Check EPROM Is Blank"
    LOCATE 9, 15
    PRINT "3  -  Program EPROM from Data On Disk"
    LOCATE 11, 15
    PRINT "4  -  Verify EPROM Against Data On Disk"
    LOCATE 13, 15
    PRINT "5  -  Change EPROM Type"
    LOCATE 15, 15
    PRINT "6  -  Run Hex File Convertor"
    LOCATE 17, 15
    PRINT "7  -  DOS Shell"
    LOCATE 19, 13
    PRINT "Esc  -  Exit"
    COLOR 11
    LOCATE 21, 27
    PRINT "EPROM Type Selected = "; Device$
    LOCATE 25, 28
    COLOR 14
    PRINT "(C) 1994 Paul Stenning";
    COLOR 7
    FromProg% = 0
MenuLoop:
    DO
        Key$ = INKEY$
    LOOP UNTIL Key$ <> ""
    SELECT CASE Key$
        CASE "1"
            GOTO ReadEprom
        CASE "2"
            GOTO BlankEprom
        CASE "3"
            GOTO ProgramEprom
        CASE "4"
            GOTO VerifyEprom
        CASE "5"
            GOTO Top
        CASE "6"
            CLS
            SHELL "HEX-CONV"
            GOTO MainMenu
        CASE "7"
            CLS
            PRINT "Type 'EXIT' to return to EPROM Programmer"
            SHELL
            GOTO MainMenu
        CASE CHR$(27)
            GOSUB Quit
    END SELECT
    GOTO MenuLoop

ReadEprom:
    CLS
    COLOR 7
    LOCATE 4, 23
    PRINT "Switch Programmer to <"; Device$; "> and <Off>"
    LOCATE 6, 15
    PRINT "Insert EPROM to Read, then Switch Programmer to <Read>"
    LOCATE 8, 12
    PRINT "Press <Reset> on Programmer, then Press any Key to Continue"
    DO: Key$ = INKEY$: LOOP UNTIL Key$ <> ""
    IF Key$ = CHR$(27) THEN GOTO MainMenu
    COLOR 14
    LOCATE 13, 13
    INPUT "Enter Output File Name (.HEX Extension Assumed) ", File$
    IF File$ = "" THEN GOTO MainMenu
    Abort% = 0
    IF LEN(File$) > 8 THEN Abort% = 1
    File$ = UCASE$(File$)
    Bad$ = " []^*?|\#:;<>,./'=+`" + CHR$(34)
    FOR Temp% = 1 TO LEN(Bad$)
        IF INSTR(File$, MID$(Bad$, Temp%, 1)) > 0 THEN
            Abort% = 1
            EXIT FOR
        END IF
    NEXT
    IF Abort% = 1 THEN
        LOCATE 22, 18
        COLOR 12
        PRINT "Invalid File Name - Press Any Key To Continue"
        BEEP
        DO
        LOOP UNTIL INKEY$ <> ""
        GOTO MainMenu
    END IF
    File$ = File$ + ".HEX"
    ON ERROR GOTO FileError
    OPEN File$ FOR OUTPUT AS #2
    COLOR 15
    PRINT #2, Device$
    PRINT #2,
    Fail% = 0
    FOR Addr& = 0 TO (MaxAddr& - 15) STEP 16
        IF INKEY$ = CHR$(27) THEN
            COLOR 12
            LOCATE 17, 32
            PRINT "*** ABORTED! ***"
            BEEP
            Fail% = 1
        END IF
        Addr$ = HEX$(Addr&)
        DO UNTIL LEN(Addr$) = 4: Addr$ = "0" + Addr$: LOOP
        PRINT #2, Addr$; TAB(9);
        FOR Count% = 0 TO 15
            Byte$ = "00"
            ON ERROR GOTO GetByteError
            GOSUB SendByte
            GOSUB GetByte
            ON ERROR GOTO FileError
            PRINT #2, Byte$; " ";
        NEXT
        LOCATE 20, 25
        PRINT "Reading Location"; Addr&; "of"; MaxAddr&;
        PRINT #2,
        IF Fail% = 1 THEN EXIT FOR
    NEXT
ReadDone:
    PRINT #2,
    CLOSE #2
    COLOR 15
    LOCATE 20, 12
    PRINT "Switch Programmer to <Off> then Press any Key to Continue";
    DO: LOOP UNTIL INKEY$ <> ""
    GOTO MainMenu

BlankEprom:
    CLS
    COLOR 7
    LOCATE 4, 23
    PRINT "Switch Programmer to <"; Device$; "> and <Off>"
    LOCATE 6, 12
    PRINT "Insert EPROM to Blank Check, then Switch Programmer to <Read>"
    LOCATE 8, 12
    PRINT "Press <Reset> on Programmer, then Press any Key to Continue"
    DO: Key$ = INKEY$: LOOP UNTIL Key$ <> ""
    IF Key$ = CHR$(27) THEN GOTO MainMenu
    COLOR 15
    Fail% = 0
    ON ERROR GOTO GetByteError
    FOR Addr& = 0 TO (MaxAddr& - 15) STEP 16
        IF INKEY$ = CHR$(27) THEN
            COLOR 12
            LOCATE 17, 32
            PRINT "*** ABORTED! ***"
            Fail% = 1
            BEEP
        END IF
        FOR Count% = 0 TO 15
            Byte$ = "00"
            GOSUB SendByte
            GOSUB GetByte
            IF Byte$ <> "FF" THEN
                COLOR 12
                IF Fail% = 0 THEN
                    LOCATE 17, 20
                    PRINT "*** EPROM NOT BLANK AT ADDRESS"; Addr& + Count%; "***"
                    BEEP
                END IF
                Fail% = 1
            END IF
        NEXT
        LOCATE 20, 25
        PRINT "Checking Location"; Addr&; "of"; MaxAddr&;
        IF Fail% = 1 THEN EXIT FOR
    NEXT
BlankDone:
    IF Fail% = 0 THEN
        COLOR 10
        LOCATE 17, 29
        PRINT "*** EPROM IS BLANK ***"
    END IF
    COLOR 15
    LOCATE 20, 12
    PRINT "Switch Programmer to <Off> then Press any Key to Continue";
    DO: LOOP UNTIL INKEY$ <> ""
    GOTO MainMenu

ProgramEprom:
    CLS
    COLOR 7
    LOCATE 4, 23
    PRINT "Switch Programmer to <"; Device$; "> and <Off>"
    LOCATE 6, 12
    PRINT "Insert EPROM to Program, then Switch Programmer to <Program>"
    LOCATE 8, 12
    PRINT "Press <Reset> on Programmer, then Press any Key to Continue"
    DO: Key$ = INKEY$: LOOP UNTIL Key$ <> ""
    IF Key$ = CHR$(27) THEN GOTO MainMenu
    COLOR 14
    LOCATE 13, 13
    INPUT "Enter Input File Name (.HEX Extension Assumed) ", File$
    IF File$ = "" THEN GOTO MainMenu
    Abort% = 0
    IF LEN(File$) > 8 THEN Abort% = 1
    File$ = UCASE$(File$)
    Bad$ = " []^*?|\#:;<>,./'=+`" + CHR$(34)
    FOR Temp% = 1 TO LEN(Bad$)
        IF INSTR(File$, MID$(Bad$, Temp%, 1)) > 0 THEN
            Abort% = 1
            EXIT FOR
        END IF
    NEXT
    IF Abort% = 1 THEN
        LOCATE 22, 18
        COLOR 12
        PRINT "Invalid File Name - Press Any Key To Continue"
        BEEP
        DO
        LOOP UNTIL INKEY$ <> ""
        GOTO MainMenu
    END IF
    File$ = File$ + ".HEX"
    ON ERROR GOTO FileError
    OPEN File$ FOR INPUT AS #2
    COLOR 15
    LINE INPUT #2, Dat$
    IF LEN(Dat$) > 5 THEN
        SEEK #2, 1
    ELSE
        IF Dat$ <> Device$ THEN
            COLOR 12
            LOCATE 17, 24
            PRINT "FILE DOES NOT MATCH EPROM TYPE"
            BEEP
            GOTO ProgDone
        END IF
        LINE INPUT #2, Dat$
    END IF
    PRINT
    COLOR 15
    Fail% = 0
    FOR Addr& = 0 TO (MaxAddr& - 15) STEP 16
        IF INKEY$ = CHR$(27) THEN
            COLOR 12
            LOCATE 17, 32
            PRINT "*** ABORTED! ***"
            BEEP
            Fail% = 1
        END IF
        IF EOF(2) THEN
            EXIT FOR
        END IF
        ON ERROR GOTO FileError
        LINE INPUT #2, Dat$
        Dat& = VAL("&h" + LEFT$(Dat$, 4))
        IF Dat& < 0 THEN Dat& = Dat& + 65536
        IF Dat& <> Addr& THEN
            COLOR 12
            LOCATE 17, 32
            PRINT "FILE ADDRESSES NOT CONTINUOUS"
            BEEP
            Fail% = 1
        END IF
        FOR Count% = 0 TO 15
            Byte$ = MID$(Dat$, 9 + Count% * 3, 2)
            ON ERROR GOTO GetByteError
            GOSUB SendByte
            Temp$ = Byte$
            GOSUB GetByte
            IF Byte$ <> Temp$ THEN
                COLOR 12
                LOCATE 17, 25
                PRINT "PROGRAMMER OR COMMUNICATION ERROR"
                BEEP
                Fail% = 1
            END IF
        NEXT
        LOCATE 20, 22
        PRINT "Programming Location"; Addr&; "of"; MaxAddr&;
        IF Fail% = 1 THEN EXIT FOR
    NEXT
ProgDone:
    CLOSE #2
    COLOR 15
    LOCATE 20, 12
    PRINT "Switch Programmer to <Off> then Press any Key to Continue";
    DO: LOOP UNTIL INKEY$ <> ""
    LOCATE 22, 24
    COLOR 12
    PRINT "Do you Want to Verify this EPROM ? ";
    DO
        Key$ = UCASE$(INKEY$)
    LOOP UNTIL Key$ = "Y" OR Key$ = "N" OR Key$ = CHR$(27)
    FromProg% = 1
    IF Key$ = "Y" THEN GOTO VerifyEprom
    GOTO MainMenu

VerifyEprom:
    CLS
    COLOR 7
    LOCATE 4, 23
    PRINT "Switch Programmer to <"; Device$; "> and <Off>"
    LOCATE 6, 14
    PRINT "Insert EPROM to Verify, then Switch Programmer to <Read>"
    LOCATE 8, 12
    PRINT "Press <Reset> on Programmer, then Press any Key to Continue"
    DO: Key$ = INKEY$: LOOP UNTIL Key$ <> ""
    IF Key$ = CHR$(27) THEN GOTO MainMenu
    IF FromProg% = 0 THEN
        COLOR 14
        LOCATE 13, 13
        INPUT "Enter Input File Name (.HEX Extension Assumed) ", File$
        IF File$ = "" THEN GOTO MainMenu
        Abort% = 0
        IF LEN(File$) > 8 THEN Abort% = 1
        File$ = UCASE$(File$)
        Bad$ = " []^*?|\#:;<>,./'=+`" + CHR$(34)
        FOR Temp% = 1 TO LEN(Bad$)
            IF INSTR(File$, MID$(Bad$, Temp%, 1)) > 0 THEN
                Abort% = 1
                EXIT FOR
            END IF
        NEXT
        IF Abort% = 1 THEN
            LOCATE 22, 18
            COLOR 12
            PRINT "Invalid File Name - Press Any Key To Continue"
            BEEP
            DO
            LOOP UNTIL INKEY$ <> ""
            GOTO MainMenu
        END IF
        File$ = File$ + ".HEX"
    END IF
    ON ERROR GOTO FileError
    OPEN File$ FOR INPUT AS #2
    COLOR 15
    LINE INPUT #2, Dat$
    IF LEN(Dat$) > 5 THEN
        SEEK #2, 1
    ELSE
        IF Dat$ <> Device$ THEN
            COLOR 12
            LOCATE 17, 24
            PRINT "FILE DOES NOT MATCH EPROM TYPE"
            BEEP
            GOTO VerifyDone
        END IF
        LINE INPUT #2, Dat$
    END IF
    PRINT
    COLOR 15
    Fail% = 0
    FOR Addr& = 0 TO (MaxAddr& - 15) STEP 16
        IF INKEY$ = CHR$(27) THEN
            COLOR 12
            LOCATE 17, 32
            PRINT "*** ABORTED! ***"
            BEEP
            Fail% = 1
        END IF
        IF EOF(2) THEN
            EXIT FOR
        END IF
        ON ERROR GOTO FileError
        LINE INPUT #2, Dat$
        Dat& = VAL("&h" + LEFT$(Dat$, 4))
        IF Dat& < 0 THEN Dat& = Dat& + 65536
        IF Dat& <> Addr& THEN
            COLOR 12
            LOCATE 17, 32
            PRINT "FILE ADDRESSES NOT CONTINUOUS"
            BEEP
            Fail% = 1
        END IF
        FOR Count% = 0 TO 15
            Temp$ = MID$(Dat$, 9 + (Count% * 3), 2)
            ON ERROR GOTO GetByteError
            Byte$ = "00"
            GOSUB SendByte
            GOSUB GetByte
            IF Byte$ <> Temp$ THEN
                COLOR 12
                IF Fail% = 0 THEN
                    LOCATE 17, 25
                    PRINT "*** VERIFY FAILED AT ADDRESS"; Addr& + Count%; "***"
                    BEEP
                END IF
                Fail% = 1
            END IF
        NEXT
        LOCATE 20, 22
        PRINT "Verifying Location"; Addr&; "of"; MaxAddr&;
        IF Fail% = 1 THEN EXIT FOR
    NEXT
VerifyDone:
    CLOSE #2
    IF Fail% = 0 THEN
        COLOR 10
        LOCATE 17, 27
        PRINT "*** EPROM VERIFIED OK ***"
    END IF
    COLOR 15
    LOCATE 20, 12
    PRINT "Switch Programmer to <Off> then Press any Key to Continue";
    DO: LOOP UNTIL INKEY$ <> ""
    GOTO MainMenu

SendByte:
    PRINT #1, CHR$(VAL("&h" + Byte$));
    RETURN

GetByte:
    Timeout = TIMER + .1
    DO WHILE EOF(1) AND Timeout > TIMER
    LOOP
    IF NOT EOF(1) THEN
        Byte$ = HEX$(ASC(INPUT$(1, #1)))
        IF LEN(Byte$) < 2 THEN Byte$ = "0" + Byte$
    ELSE
        GOTO GetByteError
    END IF
    RETURN

OpenCom:
    ON ERROR GOTO OpenError
    IF RIGHT$(COMMAND$, 2) = "/2" THEN
        OPEN "COM2:9600,N,8,1,CS0,CD0,DS0" FOR RANDOM AS #1
    ELSE
        OPEN "COM1:9600,N,8,1,CS0,CD0,DS0" FOR RANDOM AS #1
    END IF
    ON ERROR GOTO 0
    RETURN

OpenError:
    CLOSE
    COLOR 7
    CLS
    LOCATE 2, 1
    COLOR 12
    IF RIGHT$(COMMAND$, 2) = "/2" THEN
        PRINT "Fatal Error Opening COM2"
    ELSE
        PRINT "Fatal Error Opening COM1"
    END IF
    COLOR 7
    BEEP
    LOCATE 5, 1
    END

GetByteError:
    CLOSE
    COLOR 7
    CLS
    LOCATE 2, 1
    COLOR 12
    PRINT "Fatal Communication Error"
    COLOR 7
    BEEP
    LOCATE 5, 1
    END

FileError:
    CLOSE
    COLOR 7
    CLS
    LOCATE 2, 1
    COLOR 12
    PRINT "Fatal File Error"
    COLOR 7
    BEEP
    LOCATE 5, 1
    END

Quit:
    LOCATE 23, 30
    COLOR 12
    PRINT " Exit To DOS [Y/N] ? ";
    DO
        Key$ = UCASE$(INKEY$)
    LOOP UNTIL Key$ <> ""
    COLOR 7
    SELECT CASE Key$
        CASE "N", CHR$(27)
            LOCATE 23, 30
            PRINT SPACE$(20);
            RETURN
        CASE "Y"
            CLOSE
            CLS
            PRINT
            PRINT "Goodbye!"
            PRINT
            END
    END SELECT
    GOTO Quit

WrongDos:
    PRINT
    PRINT "MS-DOS Version 3.00 or Higher Required"
    PRINT
    END

DosError:
    PRINT
    PRINT "Error Writing to Disk"
    PRINT
    END

Help:
    PRINT
    PRINT
    PRINT "EPROM Programmer Control Software"
    PRINT "(C) 1994 Paul Stenning"
    PRINT
    PRINT
    PRINT "EPROM <Options>"
    PRINT
    PRINT "Options"
    PRINT "        /1  =  Use COM1 (default)"
    PRINT "        /2  =  Use COM2"
    PRINT "        /?  =  Display this help information"
    PRINT
    PRINT
    END

